"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var hash_sum_1 = __importDefault(require("hash-sum"));
var Config_1 = __importDefault(require("./Config"));
var terser_webpack_plugin_1 = __importDefault(require("terser-webpack-plugin"));
var Optimization = (function (_super) {
    __extends(Optimization, _super);
    function Optimization() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Optimization.prototype.register = function () {
        var _this = this;
        var splitChunks = {
            minSize: 0,
            chunks: "all",
            maxInitialRequests: Infinity,
            cacheGroups: {
                vendors: {
                    test: /[\\/]node_modules[\\/]/,
                    priority: -10,
                    name: "vendor",
                    chunks: "initial",
                },
                default: {
                    minChunks: 2,
                    priority: -20,
                    chunks: "initial",
                    reuseExistingChunk: true,
                },
            },
        };
        if (this.bundler.config.aggressiveVendorSplitting) {
            splitChunks.cacheGroups.vendors = {
                test: /[\\/]node_modules[\\/]/,
                name: function (module) {
                    var packageName = module.context.match(/[\\/]node_modules[\\/](.*?)([\\/]|$)/);
                    if (packageName) {
                        return _this.bundler.env.isProduction
                            ? (0, hash_sum_1.default)(packageName[1])
                            : "vendor." + packageName[1];
                    }
                    else {
                        return (0, hash_sum_1.default)("unknown");
                    }
                },
            };
        }
        this.bundler.webpackChain.optimization
            .splitChunks(splitChunks)
            .runtimeChunk(true)
            .noEmitOnErrors(this.bundler.env.isProduction)
            .minimizer("minify")
            .use(terser_webpack_plugin_1.default, [
            {
                parallel: true,
                terserOptions: {
                    mangle: true,
                    safari10: true,
                    keep_fnames: true,
                    output: {
                        comments: false,
                    },
                },
            },
        ]);
    };
    return Optimization;
}(Config_1.default));
exports.default = Optimization;
//# sourceMappingURL=Optimization.js.map