"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Loader_1 = __importDefault(require("./Loader"));
var WebWorkers = (function (_super) {
    __extends(WebWorkers, _super);
    function WebWorkers() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WebWorkers.prototype.register = function () {
        this.bundler.webpackChain.output.globalObject("(typeof self !== 'undefined' ? self : this)");
        this.bundler.webpackChain.module.rule("js").uses.delete("thread-loader");
        this.bundler.webpackChain.module
            .rule("typescript")
            .uses.delete("thread-loader");
        this.bundler.webpackChain.module.rule("js").exclude.add(/\.worker\.js$/);
        this.bundler.webpackChain.module
            .rule("typescript")
            .exclude.add(/\.worker\.js$/);
        this.bundler.webpackChain.module
            .rule("workers")
            .test(/\.worker\.js$/)
            .use("worker-loader")
            .loader("worker-loader")
            .end()
            .use("babel")
            .loader("babel-loader")
            .end();
        this.bundler.webpackChain.module
            .rule("type-script-service-workers")
            .test(/\.worker\.tsx?$/)
            .use("babel")
            .loader("babel-loader")
            .end()
            .use("ts-loader")
            .loader("ts-loader")
            .options({
            happyPackMode: true,
            transpileOnly: this.bundler.env.isHot || this.bundler.env.isProduction,
        })
            .end();
        this.bundler.webpackChain.module
            .rule("service-workers")
            .test(/\.service-worker\.js$/)
            .use("file")
            .loader("file-loader")
            .options({
            name: "service-workers/[name].js",
        })
            .end()
            .use("babel")
            .loader("babel-loader")
            .end();
        this.bundler.webpackChain.module
            .rule("type-script-service-workers")
            .test(/\.service-worker\.tsx?$/)
            .use("file")
            .loader("file-loader")
            .options({
            name: "service-workers/[name].js",
        })
            .end()
            .use("babel")
            .loader("babel-loader")
            .end()
            .use("ts-loader")
            .loader("ts-loader")
            .options({
            happyPackMode: true,
            transpileOnly: this.bundler.env.isHot || this.bundler.env.isProduction,
        })
            .end();
    };
    return WebWorkers;
}(Loader_1.default));
exports.default = WebWorkers;
//# sourceMappingURL=WebWorkers.js.map